#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2fourteen4search.py">
#<abstract4xi abstract = "shoots to direction fourteen"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2fourteen4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2fourteen4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2fourteen4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4fourteen

global count2ack4fourteen
global count2nack4fourteen
global count2found4fourteen
global count2short4fourteen

global current2series4fourteen
global candidate2series4fourteen

global fileobject4fourteen  

global keys2profile4fourteen
global key2profile4fourteen

global left2find4fourteen

global maxsize2ack4fourteen    
global maxsize2file4fourteen 
global max2short4fourteen
global meansize2ack4fourteen
global minsize2ack4fourteen

global fourteen2analyse4search

global profile2fetch4fourteen

global right2find4fourteen

global sumsize2ack4fourteen    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4fourteen = VersionKB4Xi['base2shoot4fourteen']             # base internet address, None=local url

count2ack4fourteen   = 0
count2nack4fourteen  = 0
count2found4fourteen = 0
count2short4fourteen = 0

left2find4fourteen = '('

max2short4fourteen = VersionKB4Xi['max2short4fourteen']
maxsize2file4fourteen = VersionKB4Xi['maxsize2file4fourteen']
maxsize2ack4fourteen  = 0
meansize2ack4fourteen = 0
minsize2ack4fourteen  = 0

current2series4fourteen = "current2series4fourteen5dummy"
candidate2series4fourteen  = "candidate2series4fourteen5dummy"


fourteen2analyse4search  = VersionKB4Xi['fourteen2analyse4search']

profile2fetch4fourteen = {}
profile2fetch4fourteen [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4fourteen [2] = '.jpg'
keys2profile4fourteen = profile2fetch4fourteen.keys()

right2find4fourteen = ')'

sumsize2ack4fourteen  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4fourteen" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4fourteen(target2explore4fourteen):
    global count2ack4fourteen
    global count2nack4fourteen
    global count2found4fourteen
    global count2short4fourteen
    
    global fileobject4fourteen 
       
    global keys2profile4fourteen
    global key2profile4fourteen
    
    global left2find4fourteen

    global max2short4fourteen    
    global maxsize2file4fourteen     
    global maxsize2ack4fourteen    
    global meansize2ack4fourteen
    global minsize2ack4fourteen
  
    global candidate2series4fourteen
    global current2series4fourteen
    
    
    global profile2fetch4fourteen                         # extension for files
    
    global right2find4fourteen
    
    global sumsize2ack4fourteen    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4fourteen = count2found4fourteen + 1
    ack2debug4fourteen = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4fourteen)
    
    ack2profile = False
    for key2profile4fourteen in keys2profile4fourteen:
        if name2target[1] == profile2fetch4fourteen[key2profile4fourteen]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2FOURTEEN4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4fourteen
        if ack2debug4fourteen is True:
            print("(STEP 0A/33) OF SHOOT2FOURTEEN4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2FOURTEEN4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4fourteen:
            count2nack4fourteen = count2nack4fourteen + 1
        else:
            count2ack4fourteen = count2ack4fourteen + 1
            sumsize2ack4fourteen = sumsize2ack4fourteen + size2file
            if size2file > maxsize2ack4fourteen:
                maxsize2ack4fourteen = size2file
            if ((size2file < minsize2ack4fourteen) or (minsize2ack4fourteen == 0)):
                print("(STEP 0B/33) OF SHOOT2FOURTEEN4SEARCH - USING MINSIZE2ACK4FOURTEEN: ", minsize2ack4fourteen, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4FOURTEEN:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2fourteen//d\fourteenfly29july2012\fourteenfly29july2012 (1).JPG 
                # USING MINSIZE2ACK4FOURTEEN:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2fourteen//d\fourteenfly29july2012\fourteenfly29july2012 (2).JPG
                minsize2ack4fourteen = size2file
                print("(STEP 0C/33) OF SHOOT2FOURTEEN4SEARCH - SET MINSIZE2ACK4FOURTEEN TO: ", minsize2ack4fourteen, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4FOURTEEN TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2fourteen//d\fourteenfly29july2012\fourteenfly29july2012 (1).JPG
                # SET MINSIZE2ACK4FOURTEEN TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2fourteen//d\fourteenfly29july2012\fourteenfly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4fourteen = target2explore4fourteen
            if ack2debug4fourteen is True:print("(STEP 1A/33) OF SHOOT2FOURTEEN4SEARCH - URL2WEB4FOURTEEN: ", url2web4fourteen) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4fourteen,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4fourteen = url2web4fourteen[0:index2edit] + string2use + url2web4fourteen[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4fourteen)
            shortname2web4fourteen = name2web[0]
            if ack2debug4fourteen is True:
                print("(STEP 1B/33) OF SHOOT2FOURTEEN4SEARCH - SHORTNAME2WEB4FOURTEEN: ", shortname2web4fourteen)
                # 
            
            string2find4fourteen = '/'
            ackall2found4fourteen = False           
            while 1:
                if ackall2found4fourteen is True:
                    break
                else:
                    index2find4fourteen=str.find(shortname2web4fourteen,string2find4fourteen)   
                    if index2find4fourteen == -1:
                        ackall2found4fourteen = True
                    else:
                        shortname2web4fourteen = shortname2web4fourteen[index2find4fourteen+1:]
                        
            if ack2debug4fourteen is True:            
                print("(STEP 1C/33) OF SHOOT2FOURTEEN4SEARCH - SHORTNAME2WEB4FOURTEEN: ", shortname2web4fourteen)
                # 
                
            ackall2found4fourteen = False 
            while 1:
                if ackall2found4fourteen is True:
                    break
                else:
                    index2left4fourteen=str.find(shortname2web4fourteen,left2find4fourteen)
                    if index2left4fourteen == -1:
                        current2series4fourteen = shortname2web4fourteen
                        if ack2debug4fourteen is True:
                            print("(STEP 2A/33) OF SHOOT2FOURTEEN4SEARCH - CURRENT2SERIES4FOURTEEN: ", current2series4fourteen) 
                            # 
                        ackall2found4fourteen = True
                         
                    else:
                        index2right4fourteen=str.find(shortname2web4fourteen,right2find4fourteen)
                        if index2right4fourteen == -1:
                            ackall2found4fourteen = True 
                        else:
                            candidate2series4fourteen = shortname2web4fourteen[0:index2left4fourteen]
                            
                            index3find4fourteen=str.find(shortname2web4fourteen,current2series4fourteen)
                            if index3find4fourteen == -1:
                                
                                current2series4fourteen = candidate2series4fourteen
                                if ack2debug4fourteen is True:
                                    print("(STEP 2B/33) OF SHOOT2FOURTEEN4SEARCH - CURRENT2SERIES4FOURTEEN: ", current2series4fourteen) 
                                    # 
                                
                                count2short4fourteen = 0
                                fileobject4fourteen.write('<br />' + '\n')
                            else:
                                shortname2web4fourteen = shortname2web4fourteen[index2left4fourteen:index2right4fourteen+1]
                                if ack2debug4fourteen is True:
                                    print("(STEP 2C/33) OF SHOOT2FOURTEEN4SEARCH - SHORTNAME2WEB4FOURTEEN: ", shortname2web4fourteen)
                                    # 
                                
                                count2short4fourteen = count2short4fourteen + 1
                                if count2short4fourteen >= max2short4fourteen:
                                    count2short4fourteen = 0
                                else:
                                    pass       
                            ackall2found4fourteen = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4fourteen is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4fourteen.write('<br /><b>&raquo;</b><a href="' + url2web4fourteen + '" target="_blank">' + shortname2web4fourteen + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4fourteen = fourteen2analyse4search
                if ack2debug4fourteen is True:
                    print("(STEP 3A/33) OF SHOOT2FOURTEEN4SEARCH - BASE2LOCAL4FOURTEEN: ", base2local4fourteen)
                    #              
                ack2localtries4fourteen = False                   
                while 1:
                    if ack2localtries4fourteen is True:
                        break
                    else:
                        index2find4fourteen=str.find(url2web4fourteen,base2local4fourteen)            
                        # 
                        #  
                        if index2find4fourteen == -1:
                            ack2localtries4fourteen = True
                        else:
                            if ack2debug4fourteen is True:
                                print("(STEP 3B/33) OF SHOOT2FOURTEEN4SEARCH - BASE2BUILD4FOURTEEN: ", base2build4fourteen)
                                # 
                            url2web4fourteen = base2build4fourteen + url2web4fourteen[len(base2local4fourteen):]
                            if ack2debug4fourteen is True:
                                print("(STEP 3C/33) OF SHOOT2FOURTEEN4SEARCH - URL2WEB4FOURTEEN: ", url2web4fourteen)
                                # 
                            
                            if count2short4fourteen < 1: 
                                fileobject4fourteen.write('<br /><b>&raquo;</b><a href="' + url2web4fourteen + '" target="_blank">' + shortname2web4fourteen + '</a>' + '\n')
                            else:
                                fileobject4fourteen.write('<b>&raquo;</b><a href="' + url2web4fourteen + '" target="_blank">' + shortname2web4fourteen + '</a>\n')                            
                            ack2localtries4fourteen = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2FOURTEEN4SEARCH FAILED, FILEOBJECT4FOURTEEN-WRITE-FAILED: ", str(fileobject4fourteen), time4xi())
      
    else:
        
        count2nack4fourteen = count2nack4fourteen + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2fourteen4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2fourteen4search(queue2fourteen = None, consumer_channel2fourteen = None, publisher_channel2fourteen = None, path2fourteen = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4fourteen
    global count2nack4fourteen
    global count2found4fourteen
    
    global fileobject4fourteen    
    
    global maxsize2ack4fourteen    
    global meansize2ack4fourteen
    global minsize2ack4fourteen
    global sumsize2ack4fourteen    
    
    global maxsize2file4fourteen 
    
    global profile2fetch4fourteen                         # extension for files
    global keys2profile4fourteen
    global key2profile4fourteen

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2FOURTEEN4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2FOURTEEN4SEARCH -  QUEUE2FOURTEEN: ", queue2fourteen)      
    # QUEUE2FOURTEEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2FOURTEEN4SEARCH -  CONSUMER_CHANNEL2FOURTEEN: ", consumer_channel2fourteen)
    # CONSUMER_CHANNEL2FOURTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2FOURTEEN4SEARCH -  PUBLISHER_CHANNEL2FOURTEEN: ", publisher_channel2fourteen)          
    # PUBLISHER_CHANNEL2FOURTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2fourteen is None) or (consumer_channel2fourteen is None) or (publisher_channel2fourteen is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2FOURTEEN4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2FOURTEEN4SEARCH - QUEUE2FOURTEEN: ", queue2fourteen)
        print("(STEP 1C/33) OF SHOOT2FOURTEEN4SEARCH - CONSUMER_CHANNEL2FOURTEEN: ", consumer_channel2fourteen) 
        print("(STEP 1D/33) OF SHOOT2FOURTEEN4SEARCH - PUBLISHER_CHANNEL2FOURTEEN: ", publisher_channel2fourteen)
        print("(STEP 1E/33) OF SHOOT2FOURTEEN4SEARCH - PATH2FOURTEEN: ", path2fourteen)     
        
        return
 
    if (not (queue2fourteen is None) and not(consumer_channel2fourteen is None) and not(publisher_channel2fourteen is None) and (path2fourteen is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2FOURTEEN4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2FOURTEEN4SEARCH - QUEUE2FOURTEEN: ", queue2fourteen)
        print("(STEP 2C/33) OF SHOOT2FOURTEEN4SEARCH - CONSUMER_CHANNEL2FOURTEEN: ", consumer_channel2fourteen) 
        print("(STEP 2D/33) OF SHOOT2FOURTEEN4SEARCH - PUBLISHER_CHANNEL2FOURTEEN: ", publisher_channel2fourteen)
        print("(STEP 2E/33) OF SHOOT2FOURTEEN4SEARCH - PATH2FOURTEEN: ", path2fourteen)     
        return           

    if (not (queue2fourteen is None) and not(consumer_channel2fourteen is None) and not(publisher_channel2fourteen is None) and not(path2fourteen is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2FOURTEEN4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2FOURTEEN4SEARCH - QUEUE2FOURTEEN: ", queue2fourteen)
        # QUEUE2FOURTEEN:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2FOURTEEN4SEARCH - CONSUMER_CHANNEL2FOURTEEN: ", consumer_channel2fourteen)
        # CONSUMER_CHANNEL2FOURTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2FOURTEEN4SEARCH - PUBLISHER_CHANNEL2FOURTEEN: ", publisher_channel2fourteen)
        # PUBLISHER_CHANNEL2FOURTEEN:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2FOURTEEN4SEARCH - PATH2FOURTEEN: ", path2fourteen)
        # PATH2FOURTEEN:  F://temp//yophotos//test2fourteen//
       
        print("(STEP 4A/33) OF SHOOT2FOURTEEN4SEARCH - STARTING TO WALK PATH2FOURTEEN: ", path2fourteen)   
        # STARTING TO WALK PATH2FOURTEEN:  F://temp//yophotos//test2fourteen//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4fourteen = None
        try:
            name2index4fourteen = "index2xxxxxxxx4yo.html"
            path2index4fourteen = path2fourteen + name2index4fourteen
            print("(Step 4B/33) OF SHOOT2FOURTEEN4SEARCH - SET PATH2INDEX4FOURTEEN TO: ", path2index4fourteen)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4FOURTEEN: ", path2index4fourteen)          
            #                    
        fileobject4fourteen = None
        try:
            fileobject4fourteen = open(path2index4fourteen,'w')
            print("(Step 4C/33) OF SHOOT2FOURTEEN4SEARCH - OPENED OUTPUT: ", fileobject4fourteen)
            # SHOOT2FOURTEEN4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2fourteen//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4fourteen)         
            # 
        try:                
            fileobject4fourteen.write('<html>\n')
            
            fileobject4fourteen.write('<style type="text/css" media="all">\n')
            fileobject4fourteen.write(' @import "http://www.yourfourteenxi.org/css/halongbay.css";\n')
            fileobject4fourteen.write('</style> \n')
            fileobject4fourteen.write('<p>\n')
            fileobject4fourteen.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4fourteen.write('<br /><a id="000">yourfourteen<b>&Xi;</b> @Content</a>\n')
            fileobject4fourteen.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4fourteen.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4fourteen)         
            #      
        
        
        KB2name4fourteen = {}
        key2name4fourteen = 0
                 
        for file2walk in DirectoryWalker(path2fourteen):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4fourteen [key2name4fourteen] = file2walk
                    print ("KB2NAME4FOURTEEN[", key2name4fourteen, "]: ", KB2name4fourteen [key2name4fourteen])
                    # 
                    
                    key2name4fourteen = key2name4fourteen + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2FOURTEEN4SEARCH - FAILED UPDATING KB2NAME4FOURTEEN WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4fourteen(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4fourteen.write('<br /> \n')
            fileobject4fourteen.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4fourteen.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4fourteen.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4fourteen.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4fourteen.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4fourteen.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4fourteen.write('</p>\n')
            # 
            fileobject4fourteen.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4fourteen)         
            #            
        try:    
            fileobject4fourteen.close()
            print("(Step 4C/33) OF SHOOT2FOURTEEN4SEARCH - CLOSED OUTPUT: ", fileobject4fourteen)         
            # SHOOT2FOURTEEN4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2fourteen//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4fourteen)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2FOURTEEN4SEARCH - STARTING TO ANALYSE KB2NAME4FOURTEEN: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4FOURTEEN:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4fourteen  = {}
        AlphaKB4fourteen['a'] = {}
        AlphaKB4fourteen['b'] = {}
        AlphaKB4fourteen['c'] = {}
        AlphaKB4fourteen['d'] = {}
        AlphaKB4fourteen['e'] = {}
        AlphaKB4fourteen['f'] = {}
        AlphaKB4fourteen['g'] = {}
        AlphaKB4fourteen['h'] = {}
        AlphaKB4fourteen['i'] = {}
        AlphaKB4fourteen['j'] = {}
        AlphaKB4fourteen['k'] = {}
        AlphaKB4fourteen['l'] = {}
        AlphaKB4fourteen['m'] = {}
        AlphaKB4fourteen['n'] = {}
        AlphaKB4fourteen['o'] = {}
        AlphaKB4fourteen['p'] = {}
        AlphaKB4fourteen['q'] = {}
        AlphaKB4fourteen['r'] = {}
        AlphaKB4fourteen['s'] = {}
        AlphaKB4fourteen['t'] = {}
        AlphaKB4fourteen['u'] = {}
        AlphaKB4fourteen['v'] = {}
        AlphaKB4fourteen['w'] = {}
        AlphaKB4fourteen['x'] = {}
        AlphaKB4fourteen['y'] = {}
        AlphaKB4fourteen['z'] = {} 
        keys2AlphaKB4fourteen = AlphaKB4fourteen.keys()
        key2AlphaKB4fourteen  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4fourteen = len(path2fourteen)
        # 
        
        keys2name4fourteen = KB2name4fourteen.keys()
                
        for key2name4fourteen in sorted(keys2name4fourteen):
            # 
            name2optimize4fourteen = KB2name4fourteen[key2name4fourteen]
            # 
            shortcut2level4fourteen = name2optimize4fourteen[len2cut4fourteen:]
            # 
            len2shortcut4fourteen = len(shortcut2level4fourteen)
            if len2shortcut4fourteen == 1:
                try:
                    # LEVEL FOURTEEN CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4fourteen in keys2AlphaKB4fourteen:
                        KB2level1[key2level1] = shortcut2level4fourteen
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2FOURTEEN4SEARCH ** WARNING - SHORTCUT2LEVEL4FOURTEEN: ", shortcut2level4fourteen, " NOT IN KEYS2ALPHAKB4FOURTEEN: ", keys2AlphaKB4fourteen)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED - SHORTCUT2LEVEL4FOURTEEN: ", shortcut2level4fourteen)      
            else:
                try:
                    
                    string2search4fourteen = '\\'
                    shortcut2level4fourteen = shortcut2level4fourteen[2:]
                    
                    index2level4fourteen=str.find(shortcut2level4fourteen,string2search4fourteen)
                    if index2level4fourteen == -1:
                         
                        KB2level2[key2level2] = shortcut2level4fourteen
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4fourteen = shortcut2level4fourteen[index2level4fourteen+1:]
                        index2level4fourteen=str.find(shortcut2level4fourteen,string2search4fourteen)
                        if index2level4fourteen == -1:
                            KB2level3[key2level3] = shortcut2level4fourteen
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4fourteen = shortcut2level4fourteen[index2level4fourteen+1:]
                            index2level4fourteen=str.find(shortcut2level4fourteen,string2search4fourteen)
                            if index2level4fourteen == -1:
                                KB2level4[key2level4] = shortcut2level4fourteen
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4fourteen = shortcut2level4fourteen[index2level4fourteen+1:]
                                index2level4fourteen=str.find(shortcut2level4fourteen,string2search4fourteen)
                                if index2level4fourteen == -1:
                                    KB2level5[key2level5] = shortcut2level4fourteen
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4fourteen = shortcut2level4fourteen[index2level4fourteen+1:]
                                    index2level4fourteen=str.find(shortcut2level4fourteen,string2search4fourteen)
                                    if index2level4fourteen == -1:
                                        KB2level6[key2level6] = shortcut2level4fourteen
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4fourteen = shortcut2level4fourteen[index2level4fourteen+1:]
                                        index2level4fourteen=str.find(shortcut2level4fourteen,string2search4fourteen)
                                        if index2level4fourteen == -1:
                                            KB2level7[key2level7] = shortcut2level4fourteen
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4fourteen = shortcut2level4fourteen[index2level4fourteen+1:]
                                            index2level4fourteen=str.find(shortcut2level4fourteen,string2search4fourteen)
                                            if index2level4fourteen == -1:
                                                KB2level8[key2level8] = shortcut2level4fourteen
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2FOURTEEN4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4FOURTEEN: ", shortcut2level4fourteen)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED - SHORTCUT2LEVEL4FOURTEEN: ", shortcut2level4fourteen)   
        
        print ("(Step 6A/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # fourteenfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2FOURTEEN4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2FOURTEEN4SEARCH - COUNT2ACK4FOURTEEN; ", count2ack4fourteen)
            # COUNT2ACK4FOURTEEN;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2FOURTEEN4SEARCH - COUNT2NACK4FOURTEEN; ", count2nack4fourteen)
            # COUNT2NACK4FOURTEEN;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2FOURTEEN4SEARCH - COUNT2FOUND4FOURTEEN: ", count2found4fourteen)
            # COUNT2FOUND4FOURTEEN:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2FOURTEEN4SEARCH - FOUND MAX SIZE: ", maxsize2ack4fourteen)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2FOURTEEN4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4fourteen)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4fourteen == 0:
                meansize2ack4fourteen = 0
                print ("(Step 7G1/33) OF SHOOT2FOURTEEN4SEARCH - MEAN SIZE SET: ", meansize2ack4fourteen)
                #  
            else:       
                meansize2ack4fourteen = int(sumsize2ack4fourteen / count2ack4fourteen)
                print ("(Step 7G2/33) OF SHOOT2FOURTEEN4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4fourteen, ", WHERE SUMSIZE2ACK4FOURTEEN: ", sumsize2ack4fourteen, " COUNT2ACK4FOURTEEN: ", count2ack4fourteen)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4FOURTEEN:  10944512  COUNT2ACK4FOURTEEN:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4fourteen < maxsize2file4fourteen:
                print ("(Step 7H/33) OF SHOOT2FOURTEEN4SEARCH - MIN SIZE MET: ", minsize2ack4fourteen)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2FOURTEEN4SEARCH ** MIN DEFINED: ", minsize2ack4fourteen, " EQUALS TO MAXSIZE2FILE4FOURTEEN: ", maxsize2file4fourteen)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2FOURTEEN4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2FOURTEEN4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2FOURTEEN4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2FOURTEEN4SEARCH - QUEUE2FOURTEEN: ", queue2fourteen)
        print("(STEP 7Z3/33) OF SHOOT2FOURTEEN4SEARCH - CONSUMER_CHANNEL2FOURTEEN: ", consumer_channel2fourteen) 
        print("(STEP 7Z4/33) OF SHOOT2FOURTEEN4SEARCH - PUBLISHER_CHANNEL2FOURTEEN: ", publisher_channel2fourteen)
        print("(STEP 7Z5/33) OF SHOOT2FOURTEEN4SEARCH - PATH2FOURTEEN: ", path2fourteen)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.fourteenxi.com; www.yourfourteenxi.com; www.yourfourteenxi.org; www.fourteen2xi.com/; www.fourteen4xi.com/; www.fourteen8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2fourteen4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
